/*
 * Copyright (C) 2012, Nils Asmussen <nils@os.inf.tu-dresden.de>
 * Economic rights: Technische Universitaet Dresden (Germany)
 *
 * This file is part of NRE (NOVA runtime environment).
 *
 * NRE is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * NRE is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License version 2 for more details.
 */

#include <stream/Serial.h>
#include <kobj/Pt.h>
#include <CPU.h>

using namespace nre;

static Pt *echo;

PORTAL static void portal_getcap(void*) {
    UtcbFrameRef uf;
    // TODO delegate cap
}

PORTAL static void portal_echo(void*) {
    UtcbFrameRef uf;
    // TODO receive integer
    uf.finish_input();
    // TODO echo integer back
}

// provides the echo portal
static void service() {
    Reference<LocalThread> lt = LocalThread::create(CPU::current().log_id());
    echo = new Pt(lt, portal_echo);
}

// wants to call the echo portal
static void client(Pt &getcap) {
    // TODO request echo portal cap

    int res;
    // TODO call portal

    Serial::get() << "Hello World: " << res << "\n";
}

int main() {
    service();

    // given from someone else
    Reference<LocalThread> lt = LocalThread::create(CPU::current().log_id());
    Pt getcap(lt, portal_getcap);

    client(getcap);
    return 0;
}
